VTK: vtkGenericInterpolatedVelocityField Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | Static Protected Attributes | List of all members
vtkGenericInterpolatedVelocityField Class Reference

Interface for obtaining interpolated velocity values. More...

`#include <vtkGenericInterpolatedVelocityField.h>`

Inheritance diagram for vtkGenericInterpolatedVelocityField:
[legend]
Collaboration diagram for vtkGenericInterpolatedVelocityField:
[legend]

## Public Types
typedef vtkFunctionSet | Superclass
Public Types inherited from vtkFunctionSet
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkGenericInterpolatedVelocityField * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | FunctionValues (double *x, double *f) override
| Evaluate the velocity field, f, at (x, y, z, t). More...
virtual void | AddDataSet (vtkGenericDataSet *dataset)
| Add a dataset used for the implicit function evaluation. More...
void | ClearLastCell ()
| Set the last cell id to -1 so that the next search does not start from the previous cell. More...
vtkGenericAdaptorCell * | GetLastCell ()
| Return the cell cached from last evaluation. More...
int | GetLastLocalCoordinates (double pcoords[3])
| Returns the interpolation weights cached from last evaluation if the cached cell is valid (returns 1). More...
virtual void | CopyParameters (vtkGenericInterpolatedVelocityField *from)
| Copy the user set parameters from source. More...
virtual int | FunctionValues (double *x, double *f)
| Evaluate functions at x_j. More...
virtual int | FunctionValues (double *x, double *f, void *vtkNotUsed(userData))
virtual vtkTypeBool | GetCaching ()
| Turn caching on/off. More...
virtual void | SetCaching (vtkTypeBool)
| Turn caching on/off. More...
virtual void | CachingOn ()
| Turn caching on/off. More...
virtual void | CachingOff ()
| Turn caching on/off. More...
virtual int | GetCacheHit ()
| Caching statistics. More...
virtual int | GetCacheMiss ()
| Caching statistics. More...
virtual char * | GetVectorsSelection ()
| If you want to work with an arbitrary vector array, then set its name here. More...
void | SelectVectors (const char *fieldName)
| If you want to work with an arbitrary vector array, then set its name here. More...
virtual vtkGenericDataSet * | GetLastDataSet ()
| Returns the last dataset that was visited. More...
Public Member Functions inherited from vtkFunctionSet
vtkFunctionSet * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual int | FunctionValues (double *x, double *f, void *vtkNotUsed(userData))
virtual int | GetNumberOfFunctions ()
| Return the number of functions. More...
virtual int | GetNumberOfIndependentVariables ()
| Return the number of independent variables. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkGenericInterpolatedVelocityField * | SafeDownCast (vtkObjectBase *o)
static vtkGenericInterpolatedVelocityField * | New ()
| Construct a vtkGenericInterpolatedVelocityField with no initial data set. More...
Static Public Member Functions inherited from vtkFunctionSet
static vtkTypeBool | IsTypeOf (const char *type)
static vtkFunctionSet * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkGenericInterpolatedVelocityField ()
| ~vtkGenericInterpolatedVelocityField () override
virtual void | SetVectorsSelection (const char *)
int | FunctionValues (vtkGenericDataSet *dataset, double *x, double *f)
Protected Member Functions inherited from vtkFunctionSet
| vtkFunctionSet ()
| ~vtkFunctionSet () override=default
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkGenericCellIterator * | GenCell
double | LastPCoords [3]
int | CacheHit
int | CacheMiss
vtkTypeBool | Caching
vtkGenericDataSet * | LastDataSet
char * | VectorsSelection
vtkGenericInterpolatedVelocityFieldDataSetsType * | DataSets
Protected Attributes inherited from vtkFunctionSet
int | NumFuncs
int | NumIndepVars
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Static Protected Attributes
static const double | TOLERANCE_SCALE

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

Interface for obtaining interpolated velocity values.

vtkGenericInterpolatedVelocityField acts as a continuous velocity field by performing cell interpolation on the underlying vtkDataSet. This is a concrete sub-class of vtkFunctionSet with NumberOfIndependentVariables = 4 (x,y,z,t) and NumberOfFunctions = 3 (u,v,w). Normally, every time an evaluation is performed, the cell which contains the point (x,y,z) has to be found by calling FindCell. This is a computationally expansive operation. In certain cases, the cell search can be avoided or shortened by providing a guess for the cell iterator. For example, in streamline integration, the next evaluation is usually in the same or a neighbour cell. For this reason, vtkGenericInterpolatedVelocityField stores the last cell iterator. If caching is turned on, it uses this iterator as the starting point.

Warning
  vtkGenericInterpolatedVelocityField is not thread safe. A new instance should be created by each thread.

See also
  vtkFunctionSet vtkGenericStreamTracer

Definition at line 43 of file vtkGenericInterpolatedVelocityField.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkFunctionSet vtkGenericInterpolatedVelocityField::Superclass

Definition at line 46 of file vtkGenericInterpolatedVelocityField.h.

## Constructor & Destructor Documentation

## ◆ vtkGenericInterpolatedVelocityField()

vtkGenericInterpolatedVelocityField::vtkGenericInterpolatedVelocityField | ( |  | ) |
| protected

## ◆ ~vtkGenericInterpolatedVelocityField()

vtkGenericInterpolatedVelocityField::~vtkGenericInterpolatedVelocityField | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkGenericInterpolatedVelocityField::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkGenericInterpolatedVelocityField::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkFunctionSet.

## ◆ SafeDownCast()

static vtkGenericInterpolatedVelocityField* vtkGenericInterpolatedVelocityField::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkGenericInterpolatedVelocityField::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkFunctionSet.

## ◆ NewInstance()

vtkGenericInterpolatedVelocityField* vtkGenericInterpolatedVelocityField::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkGenericInterpolatedVelocityField::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ New()

static vtkGenericInterpolatedVelocityField* vtkGenericInterpolatedVelocityField::New | ( |  | ) |
| static

Construct a vtkGenericInterpolatedVelocityField with no initial data set.

Caching is on. LastCellId is set to -1.

## ◆ FunctionValues() [1/4]

int vtkGenericInterpolatedVelocityField::FunctionValues | ( | double * | x,
|  | double * | f
| ) |  |
| overridevirtual

Evaluate the velocity field, f, at (x, y, z, t).

For now, t is ignored.

Reimplemented from vtkFunctionSet.

## ◆ AddDataSet()

virtual void vtkGenericInterpolatedVelocityField::AddDataSet | ( | vtkGenericDataSet * | dataset | ) |
| virtual

Add a dataset used for the implicit function evaluation.

If more than one dataset is added, the evaluation point is searched in all until a match is found. THIS FUNCTION DOES NOT CHANGE THE REFERENCE COUNT OF dataset FOR THREAD SAFETY REASONS.

## ◆ ClearLastCell()

void vtkGenericInterpolatedVelocityField::ClearLastCell | ( |  | ) |

Set the last cell id to -1 so that the next search does not start from the previous cell.

## ◆ GetLastCell()

vtkGenericAdaptorCell* vtkGenericInterpolatedVelocityField::GetLastCell | ( |  | ) |

Return the cell cached from last evaluation.

## ◆ GetLastLocalCoordinates()

int vtkGenericInterpolatedVelocityField::GetLastLocalCoordinates | ( | double | pcoords[3] | ) |

Returns the interpolation weights cached from last evaluation if the cached cell is valid (returns 1).

Otherwise, it does not change w and returns 0.

## ◆ GetCaching()

virtual vtkTypeBool vtkGenericInterpolatedVelocityField::GetCaching | ( |  | ) |
| virtual

Turn caching on/off.

## ◆ SetCaching()

virtual void vtkGenericInterpolatedVelocityField::SetCaching | ( | vtkTypeBool |  | ) |
| virtual

Turn caching on/off.

## ◆ CachingOn()

virtual void vtkGenericInterpolatedVelocityField::CachingOn | ( |  | ) |
| virtual

Turn caching on/off.

## ◆ CachingOff()

virtual void vtkGenericInterpolatedVelocityField::CachingOff | ( |  | ) |
| virtual

Turn caching on/off.

## ◆ GetCacheHit()

virtual int vtkGenericInterpolatedVelocityField::GetCacheHit | ( |  | ) |
| virtual

Caching statistics.

## ◆ GetCacheMiss()

virtual int vtkGenericInterpolatedVelocityField::GetCacheMiss | ( |  | ) |
| virtual

Caching statistics.

## ◆ GetVectorsSelection()

virtual char* vtkGenericInterpolatedVelocityField::GetVectorsSelection | ( |  | ) |
| virtual

If you want to work with an arbitrary vector array, then set its name here.

By default this in nullptr and the filter will use the active vector array.

## ◆ SelectVectors()

void vtkGenericInterpolatedVelocityField::SelectVectors | ( | const char * | fieldName | ) |
| inline

If you want to work with an arbitrary vector array, then set its name here.

By default this in nullptr and the filter will use the active vector array.

Definition at line 113 of file vtkGenericInterpolatedVelocityField.h.

## ◆ GetLastDataSet()

virtual vtkGenericDataSet* vtkGenericInterpolatedVelocityField::GetLastDataSet | ( |  | ) |
| virtual

Returns the last dataset that was visited.

Can be used as a first guess as to where the next point will be as well as to avoid searching through all datasets to get more information about the point.

## ◆ CopyParameters()

virtual void vtkGenericInterpolatedVelocityField::CopyParameters | ( | vtkGenericInterpolatedVelocityField * | from | ) |
| virtual

Copy the user set parameters from source.

This copies the Caching parameters. Sub-classes can add more after chaining.

## ◆ SetVectorsSelection()

virtual void vtkGenericInterpolatedVelocityField::SetVectorsSelection | ( | const char * |  | ) |
| protectedvirtual

## ◆ FunctionValues() [2/4]

int vtkGenericInterpolatedVelocityField::FunctionValues | ( | vtkGenericDataSet * | dataset,
|  | double * | x,
|  | double * | f
| ) |  |
| protected

## ◆ FunctionValues() [3/4]

virtual int vtkFunctionSet::FunctionValues
| inline

Evaluate functions at x_j.

x and f have to point to valid double arrays of appropriate sizes obtained with GetNumberOfFunctions() and GetNumberOfIndependentVariables. If you inherit this class, make sure to reimplement at least one of the two FunctionValues signatures.

Definition at line 38 of file vtkFunctionSet.h.

## ◆ FunctionValues() [4/4]

virtual int vtkFunctionSet::FunctionValues
| inline

Definition at line 39 of file vtkFunctionSet.h.

## Member Data Documentation

## ◆ GenCell

vtkGenericCellIterator* vtkGenericInterpolatedVelocityField::GenCell
| protected

Definition at line 137 of file vtkGenericInterpolatedVelocityField.h.

## ◆ LastPCoords

double vtkGenericInterpolatedVelocityField::LastPCoords[3]
| protected

Definition at line 139 of file vtkGenericInterpolatedVelocityField.h.

## ◆ CacheHit

int vtkGenericInterpolatedVelocityField::CacheHit
| protected

Definition at line 140 of file vtkGenericInterpolatedVelocityField.h.

## ◆ CacheMiss

int vtkGenericInterpolatedVelocityField::CacheMiss
| protected

Definition at line 141 of file vtkGenericInterpolatedVelocityField.h.

## ◆ Caching

vtkTypeBool vtkGenericInterpolatedVelocityField::Caching
| protected

Definition at line 142 of file vtkGenericInterpolatedVelocityField.h.

## ◆ LastDataSet

vtkGenericDataSet* vtkGenericInterpolatedVelocityField::LastDataSet
| protected

Definition at line 144 of file vtkGenericInterpolatedVelocityField.h.

## ◆ VectorsSelection

char* vtkGenericInterpolatedVelocityField::VectorsSelection
| protected

Definition at line 147 of file vtkGenericInterpolatedVelocityField.h.

## ◆ DataSets

vtkGenericInterpolatedVelocityFieldDataSetsType* vtkGenericInterpolatedVelocityField::DataSets
| protected

Definition at line 149 of file vtkGenericInterpolatedVelocityField.h.

## ◆ TOLERANCE_SCALE

const double vtkGenericInterpolatedVelocityField::TOLERANCE_SCALE
| staticprotected

Definition at line 153 of file vtkGenericInterpolatedVelocityField.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkGenericInterpolatedVelocityField.h